=== modified file 'drizzled/sql_lex.h'
--- drizzled/sql_lex.h	2009-09-21 23:07:10 +0000
+++ drizzled/sql_lex.h	2009-09-22 07:53:53 +0000
@@ -813,7 +813,6 @@
   CreateField *last_field;
   Item_sum *in_sum_func;
   drizzled::plugin::Function *udf;
-  HA_CREATE_INFO create_info;
   StorageEngine *show_engine;
   KEY_CREATE_INFO key_create_info;
   uint32_t type;

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2009-09-21 23:07:10 +0000
+++ drizzled/sql_yacc.yy	2009-09-22 07:53:53 +0000
@@ -1147,10 +1147,9 @@
             lex->alter_info.reset();
             lex->col_list.empty();
             lex->change=NULL;
-            memset(&lex->create_info, 0, sizeof(lex->create_info));
-            lex->create_info.options=$2 | $4;
-            lex->create_info.db_type= ha_default_storage_engine(session);
-            lex->create_info.default_table_charset= NULL;
+            statement->create_info.options=$2 | $4;
+            statement->create_info.db_type= ha_default_storage_engine(session);
+            statement->create_info.default_table_charset= NULL;
             lex->name.str= 0;
 
 	    message::Table *proto= &statement->create_table_proto;
@@ -1172,8 +1171,9 @@
           create2
           {
             LEX *lex= YYSession->lex;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
             lex->current_select= &lex->select_lex; 
-            assert(lex->create_info.db_type);
+            assert(statement->create_info.db_type);
           }
         | CREATE build_method opt_unique INDEX_SYM ident key_alg 
           ON table_ident
@@ -1205,18 +1205,18 @@
           }
         | CREATE DATABASE opt_if_not_exists ident
           {
-            Lex->create_info.default_table_charset= NULL;
-            Lex->create_info.used_fields= 0;
+            LEX *lex=Lex;
+
+            lex->sql_command=SQLCOM_CREATE_DB;
+            statement::CreateSchema *statement= new(std::nothrow) statement::CreateSchema(YYSession);
+            lex->statement= statement;
+            if (lex->statement == NULL)
+              DRIZZLE_YYABORT;
+            statement->create_info.options=$3;
           }
           opt_create_database_options
           {
-            LEX *lex=Lex;
-            lex->sql_command=SQLCOM_CREATE_DB;
-            lex->statement= new(std::nothrow) statement::CreateSchema(YYSession);
-            if (lex->statement == NULL)
-              DRIZZLE_YYABORT;
-            lex->name= $4;
-            lex->create_info.options=$3;
+            Lex->name= $4;
           }
         ;
 
@@ -1228,8 +1228,9 @@
           {
             Session *session= YYSession;
             LEX *lex= session->lex;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
 
-            lex->create_info.options|= HA_LEX_CREATE_TABLE_LIKE;
+            statement->create_info.options|= HA_LEX_CREATE_TABLE_LIKE;
             if (!lex->select_lex.add_table_to_list(session, $2, NULL, 0, TL_READ))
               DRIZZLE_YYABORT;
           }
@@ -1237,8 +1238,9 @@
           {
             Session *session= YYSession;
             LEX *lex= session->lex;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
 
-            lex->create_info.options|= HA_LEX_CREATE_TABLE_LIKE;
+            statement->create_info.options|= HA_LEX_CREATE_TABLE_LIKE;
             if (!lex->select_lex.add_table_to_list(session, $3, NULL, 0, TL_READ))
               DRIZZLE_YYABORT;
           }
@@ -1321,7 +1323,7 @@
         ;
 
 create_database_option:
-          default_collation {}
+          default_collation_schema {}
         ;
 
 opt_table_options:
@@ -1362,8 +1364,10 @@
 create_table_option:
           ENGINE_SYM opt_equal storage_engines
           {
-            Lex->create_info.db_type= $3;
-            Lex->create_info.used_fields|= HA_CREATE_USED_ENGINE;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            statement->create_info.db_type= $3;
+            statement->create_info.used_fields|= HA_CREATE_USED_ENGINE;
 
 	    {
 	      message::Table::StorageEngine *protoengine;
@@ -1375,10 +1379,11 @@
         | BLOCK_SIZE_SYM opt_equal ulong_num    
           { 
 	    message::Table::TableOptions *tableopts;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
 	    tableopts= ((statement::CreateTable *)Lex->statement)->create_table_proto.mutable_options();
 
             tableopts->set_block_size($3);
-            Lex->create_info.used_fields|= HA_CREATE_USED_BLOCK_SIZE;
+            statement->create_info.used_fields|= HA_CREATE_USED_BLOCK_SIZE;
           }
         | COMMENT_SYM opt_equal TEXT_STRING_sys
           {
@@ -1389,27 +1394,35 @@
           }
         | AUTO_INC opt_equal ulonglong_num
           {
-            Lex->create_info.auto_increment_value=$3;
-            Lex->create_info.used_fields|= HA_CREATE_USED_AUTO;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            statement->create_info.auto_increment_value=$3;
+            statement->create_info.used_fields|= HA_CREATE_USED_AUTO;
           }
         | ROW_FORMAT_SYM opt_equal row_types
           {
-            Lex->create_info.row_type= $3;
-            Lex->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            statement->create_info.row_type= $3;
+            statement->create_info.used_fields|= HA_CREATE_USED_ROW_FORMAT;
             Lex->alter_info.flags.set(ALTER_ROW_FORMAT);
           }
         | default_collation
         | KEY_BLOCK_SIZE opt_equal ulong_num
           {
-            Lex->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
-            Lex->create_info.key_block_size= $3;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            statement->create_info.used_fields|= HA_CREATE_USED_KEY_BLOCK_SIZE;
+            statement->create_info.key_block_size= $3;
           }
         ;
 
 default_collation:
           opt_default COLLATE_SYM opt_equal collation_name_or_default
           {
-            HA_CREATE_INFO *cinfo= &Lex->create_info;
+            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
+
+            HA_CREATE_INFO *cinfo= &statement->create_info;
             if ((cinfo->used_fields & HA_CREATE_USED_DEFAULT_CHARSET) &&
                  cinfo->default_table_charset && $4 &&
                  !my_charset_same(cinfo->default_table_charset,$4))
@@ -1418,8 +1431,28 @@
                          $4->name, cinfo->default_table_charset->csname);
                 DRIZZLE_YYABORT;
               }
-              Lex->create_info.default_table_charset= $4;
-              Lex->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
+              statement->create_info.default_table_charset= $4;
+              statement->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
+          }
+        ;
+
+default_collation_schema:
+          opt_default COLLATE_SYM opt_equal collation_name_or_default
+          {
+            statement::CreateSchema *statement= (statement::CreateSchema *)Lex->statement;
+
+            statement->create_info.default_table_charset= $4;
+            statement->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
+          }
+        ;
+
+alter_collation_schema:
+          opt_default COLLATE_SYM opt_equal collation_name_or_default
+          {
+            statement::AlterSchema *statement= (statement::AlterSchema *)Lex->statement;
+
+            statement->create_info.default_table_charset= $4;
+            statement->create_info.used_fields|= HA_CREATE_USED_DEFAULT_CHARSET;
           }
         ;
 
@@ -2072,7 +2105,8 @@
             lex->name.str= 0;
             lex->name.length= 0;
             lex->sql_command= SQLCOM_ALTER_TABLE;
-            lex->statement= new(std::nothrow) statement::AlterTable(YYSession);
+            statement::AlterTable *statement= new(std::nothrow) statement::AlterTable(YYSession);
+            lex->statement= statement;
             if (lex->statement == NULL)
               DRIZZLE_YYABORT;
             lex->duplicates= DUP_ERROR; 
@@ -2084,27 +2118,25 @@
             lex->select_lex.init_order();
             lex->select_lex.db=
               ((TableList*) lex->select_lex.table_list.first)->db;
-            memset(&lex->create_info, 0, sizeof(lex->create_info));
-            lex->create_info.db_type= 0;
-            lex->create_info.default_table_charset= NULL;
-            lex->create_info.row_type= ROW_TYPE_NOT_USED;
+            statement->create_info.db_type= 0;
+            statement->create_info.default_table_charset= NULL;
+            statement->create_info.row_type= ROW_TYPE_NOT_USED;
             lex->alter_info.reset();
             lex->alter_info.build_method= $2;
           }
           alter_commands
           {}
         | ALTER DATABASE ident_or_empty
-          {
-            Lex->create_info.default_table_charset= NULL;
-            Lex->create_info.used_fields= 0;
-          }
-          create_database_options
-          {
+          { 
             LEX *lex=Lex;
             lex->sql_command=SQLCOM_ALTER_DB;
             lex->statement= new(std::nothrow) statement::AlterSchema(YYSession);
             if (lex->statement == NULL)
               DRIZZLE_YYABORT;
+          }
+          alter_collation_schema
+          {
+            LEX *lex=Lex;
             lex->name= $3;
             if (lex->name.str == NULL &&
                 lex->copy_db_to(&lex->name.str, &lex->name.length))
@@ -2266,9 +2298,11 @@
         | CONVERT_SYM TO_SYM collation_name_or_default
           {
             LEX *lex= Lex;
-            lex->create_info.table_charset=
-            lex->create_info.default_table_charset= $3;
-            lex->create_info.used_fields|= (HA_CREATE_USED_CHARSET |
+            statement::AlterTable *statement= (statement::AlterTable *)Lex->statement;
+
+            statement->create_info.table_charset=
+            statement->create_info.default_table_charset= $3;
+            statement->create_info.used_fields|= (HA_CREATE_USED_CHARSET |
               HA_CREATE_USED_DEFAULT_CHARSET);
             lex->alter_info.flags.set(ALTER_CONVERT);
           }
@@ -4673,7 +4707,6 @@
             lex->lock_option= TL_READ;
             mysql_init_select(lex);
             lex->current_select->parsing_place= SELECT_LIST;
-            memset(&lex->create_info, 0, sizeof(lex->create_info));
           }
           show_param
           {}
@@ -4835,10 +4868,11 @@
         | CREATE DATABASE opt_if_not_exists ident
           {
             Lex->sql_command=SQLCOM_SHOW_CREATE_DB;
-            Lex->statement= new(std::nothrow) statement::ShowCreateSchema(YYSession);
+            statement::ShowCreateSchema *statement= new(std::nothrow) statement::ShowCreateSchema(YYSession);
+            Lex->statement= statement;
             if (Lex->statement == NULL)
               DRIZZLE_YYABORT;
-            Lex->create_info.options=$3;
+            statement->create_info.options=$3;
             Lex->name= $4;
           }
         | CREATE TABLE_SYM table_ident

=== modified file 'drizzled/statement/alter_schema.cc'
--- drizzled/statement/alter_schema.cc	2009-08-17 19:37:37 +0000
+++ drizzled/statement/alter_schema.cc	2009-09-22 07:53:53 +0000
@@ -28,7 +28,6 @@
 bool statement::AlterSchema::execute()
 {
   LEX_STRING *db= &session->lex->name;
-  HA_CREATE_INFO create_info(session->lex->create_info);
   if (check_db_name(db))
   {
     my_error(ER_WRONG_DB_NAME, MYF(0), db->str);

=== modified file 'drizzled/statement/alter_schema.h'
--- drizzled/statement/alter_schema.h	2009-09-21 23:07:10 +0000
+++ drizzled/statement/alter_schema.h	2009-09-22 07:53:53 +0000
@@ -36,11 +36,14 @@
   AlterSchema(Session *in_session)
     :
       Statement(in_session, SQLCOM_ALTER_DB)
-  {}
+  {
+    memset(&create_info, 0, sizeof(create_info));
+  }
 
   bool execute();
 
   drizzled::message::Table create_table_proto;
+  HA_CREATE_INFO create_info;
 };
 
 } /* end namespace statement */

=== modified file 'drizzled/statement/alter_table.cc'
--- drizzled/statement/alter_table.cc	2009-09-21 23:07:10 +0000
+++ drizzled/statement/alter_table.cc	2009-09-22 07:53:53 +0000
@@ -61,13 +61,6 @@
   Select_Lex *select_lex= &session->lex->select_lex;
   bool need_start_waiting= false;
 
-  /*
-     Code in mysql_alter_table() may modify its HA_CREATE_INFO argument,
-     so we have to use a copy of this structure to make execution
-     prepared statement- safe. A shallow copy is enough as no memory
-     referenced from this structure will be modified.
-   */
-  HA_CREATE_INFO create_info(session->lex->create_info);
   AlterInfo alter_info(session->lex->alter_info, session->mem_root);
 
   if (session->is_fatal_error) /* out of memory creating a copy of alter_info */

=== modified file 'drizzled/statement/alter_table.h'
--- drizzled/statement/alter_table.h	2009-09-21 23:07:10 +0000
+++ drizzled/statement/alter_table.h	2009-09-22 07:53:53 +0000
@@ -36,10 +36,13 @@
   AlterTable(Session *in_session)
     :
       Statement(in_session, SQLCOM_ALTER_TABLE)
-  {}
+  {
+    memset(&create_info, 0, sizeof(create_info));
+  }
 
   bool execute();
   drizzled::message::Table create_table_proto;
+  HA_CREATE_INFO create_info;
 };
 
 } /* end namespace statement */

=== modified file 'drizzled/statement/create_schema.cc'
--- drizzled/statement/create_schema.cc	2009-08-17 18:36:31 +0000
+++ drizzled/statement/create_schema.cc	2009-09-22 07:53:53 +0000
@@ -27,12 +27,6 @@
 
 bool statement::CreateSchema::execute()
 {
-  /*
-   * As mysql_create_db() may modify HA_CREATE_INFO structure passed to
-   * it, we need to use a copy of LEX::create_info to make execution
-   * prepared statement- safe.
-   */
-  HA_CREATE_INFO create_info(session->lex->create_info);
   if (! session->endActiveTransaction())
   {
     return true;

=== modified file 'drizzled/statement/create_schema.h'
--- drizzled/statement/create_schema.h	2009-08-17 18:36:31 +0000
+++ drizzled/statement/create_schema.h	2009-09-22 07:53:53 +0000
@@ -36,9 +36,12 @@
   CreateSchema(Session *in_session)
     :
       Statement(in_session, SQLCOM_CREATE_DB)
-  {}
+  {
+    memset(&create_info, 0, sizeof(create_info));
+  }
 
   bool execute();
+  HA_CREATE_INFO create_info;
 };
 
 } /* end namespace statement */

=== modified file 'drizzled/statement/create_table.cc'
--- drizzled/statement/create_table.cc	2009-09-21 23:07:10 +0000
+++ drizzled/statement/create_table.cc	2009-09-22 07:53:53 +0000
@@ -38,7 +38,7 @@
   bool link_to_local= false;
 
   /* If CREATE TABLE of non-temporary table, do implicit commit */
-  if (! (session->lex->create_info.options & HA_LEX_CREATE_TMP_TABLE))
+  if (! (create_info.options & HA_LEX_CREATE_TMP_TABLE))
   {
     if (! session->endActiveTransaction())
     {
@@ -48,14 +48,7 @@
   /* Skip first table, which is the table we are creating */
   TableList *create_table= session->lex->unlink_first_table(&link_to_local);
   TableList *select_tables= session->lex->query_tables;
-  /*
-     Code below (especially in mysql_create_table() and select_create
-     methods) may modify HA_CREATE_INFO structure in LEX, so we have to
-     use a copy of this structure to make execution prepared statement-
-     safe. A shallow copy is enough as this code won't modify any memory
-     referenced from this structure.
-   */
-  HA_CREATE_INFO create_info(session->lex->create_info);
+
   /*
      We need to copy alter_info for the same reasons of re-execution
      safety, only in case of AlterInfo we have to do (almost) a deep

=== modified file 'drizzled/statement/create_table.h'
--- drizzled/statement/create_table.h	2009-09-21 23:07:10 +0000
+++ drizzled/statement/create_table.h	2009-09-22 07:53:53 +0000
@@ -36,10 +36,13 @@
   CreateTable(Session *in_session)
     :
       Statement(in_session, SQLCOM_CREATE_TABLE)
-  {}
+  {
+    memset(&create_info, 0, sizeof(create_info));
+  }
 
   bool execute();
   drizzled::message::Table create_table_proto;
+  HA_CREATE_INFO create_info;
 };
 
 } /* end namespace statement */

=== modified file 'drizzled/statement/show_create_schema.cc'
--- drizzled/statement/show_create_schema.cc	2009-08-10 18:03:39 +0000
+++ drizzled/statement/show_create_schema.cc	2009-09-22 07:53:53 +0000
@@ -33,7 +33,6 @@
     return false;
   }
   bool res= mysqld_show_create_db(session, session->lex->name.str,
-                                  session->lex->create_info.options &
-                                  HA_LEX_CREATE_IF_NOT_EXISTS);
+                                  create_info.options & HA_LEX_CREATE_IF_NOT_EXISTS);
   return res;
 }

=== modified file 'drizzled/statement/show_create_schema.h'
--- drizzled/statement/show_create_schema.h	2009-08-10 18:03:39 +0000
+++ drizzled/statement/show_create_schema.h	2009-09-22 07:53:53 +0000
@@ -36,9 +36,12 @@
   ShowCreateSchema(Session *in_session)
     :
       Statement(in_session, SQLCOM_SHOW_CREATE_DB)
-  {}
+  {
+    memset(&create_info, 0, sizeof(create_info));
+  }
 
   bool execute();
+  HA_CREATE_INFO create_info;
 };
 
 } /* end namespace statement */

